<?php
namespace Planejamento\Logic\PrevisaoConsumo;

use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;


class ConsplanGeral
{
    public static function ProcedureConsPlan($nrlista,$dtinicial,$dtfinal,
                                             $idprodutos,$idsepprato,$preacrescimo,
                                             $idarredond,$cdprodutoini,$cdprodutofin,
                                             $cdoperador,$nrconsplanth,$nrconsplan) {

        $procedure = new Procedure('CONSPLAN_GERAL');
        $procedure->addParam(
            new Param (
                'P_NRLISTA',
                Param::PARAM_INPUT,
                $nrlista,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_DTINICIAL',
                Param::PARAM_INPUT,
                $dtinicial,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_DTFINAL',
                Param::PARAM_INPUT,
                $dtfinal,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_IDPRODUTOS',
                Param::PARAM_INPUT,
                $idprodutos,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_IDSEPPRATO',
                Param::PARAM_INPUT,
                $idsepprato,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_PEACRESCIMO',
                Param::PARAM_INPUT,
                $preacrescimo,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_IDARREDOND',
                Param::PARAM_INPUT,
                $idarredond,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_CDPRODUTOINI',
                Param::PARAM_INPUT,
                $cdprodutoini,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_CDPRODUTOFIN',
                Param::PARAM_INPUT,
                $cdprodutofin,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_CDOPERADOR',
                Param::PARAM_INPUT,
                $cdoperador,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_NRCONSPLANTH',
                Param::PARAM_INPUT,
                $nrconsplanth,
                Param::PARAM_TYPE_STR
            )
        );


        $procedure->addParam(
            new Param (
                'P_NRCONSPLAN',
                Param::PARAM_INPUT,
                $nrconsplan,
                Param::PARAM_TYPE_STR
            )

        );

        $procedure->call();

    }

    public static function DeleteConsPlan($nrconsplanth)
    {
        $conn = \Setforms2\Shared\Connection::getInstance();
        $SQL =  "DELETE FROM CONSPLAN WHERE NRCONSPLAN= ?";
        $conn->execute($SQL, array($nrconsplanth));

    }


}