<?php
namespace Services\Logic;
/**
 * Created by JetBrains PhpStorm.
 * User: leopoldosimeone
 * Date: 10/07/14
 */
use \Setforms2\Shared\ORM\DateTime;
class DateLogic
{
    public static function getIntervaloHoras($dataInicial, $dataFinal)
    {       
        //Formata os parâmetros recebidos para que estes possam ser utilizados nafunção strtotime.
        $dataInicial = str_replace('/', '-', $dataInicial);
        $dataFinal       = str_replace('/', '-', $dataFinal);
        //Na função strtotime as datas recebidas são transformadas em segundos eformatadadas na função date do php.
        $dataInicial  = date('Y/m/d H:i:s',strtotime($dataInicial)); 
        $dataFinal    = date('Y/m/d H:i:s',strtotime($dataFinal));
        //As datas formatadas são instanciadas na classe DateTime. E o objetoretornado na variavel $d_start utiliza o diff e faz a diferença com o objetoretornado na variavel $d_end
        $d_start = new DateTime($dataInicial); 
        $d_end  = new DateTime($dataFinal); 
        $diff = $d_start->diff($d_end); 
        // retorna os dados da diferença entre as datas. 
        $variaveis = get_object_vars($diff);
        // tratamento de dados do objeto retornado com o total de dias corridosdentre outros dados no array.
        $min  = str_pad($variaveis['i'], 2, "0",STR_PAD_LEFT); 
        $hour = ($variaveis['days'] * 24) + $variaveis['h']; 
        //Retorna o valor das horas contatenada com dois pontos logo apos com minutos
        return $hour.':'.$min;
    }

    public static function verificaDataEntre($dtini,$dtfin,$nrseqreg,$nrseqhorasapo = null)
    {
        if(!empty($nrseqhorasapo)){
          $where = "NRSEQHORASAPO != $nrseqhorasapo";
        }else{
          $where = "1=1";
        }
        $sql = "SELECT *
                  FROM FCT_HORASAPONT 
                 WHERE (DTINICIOAPONT BETWEEN :DTINICIOAPONT 
                   AND :DTFINALAPONT
                   OR DTFINALAPONT BETWEEN :DTINICIOAPONT 
                  AND :DTFINALAPONT
                   OR :DTINICIOAPONT BETWEEN DTINICIOAPONT 
                  AND DTFINALAPONT
                  AND :DTFINALAPONT BETWEEN DTINICIOAPONT 
                  AND DTFINALAPONT)
                  AND NRSEQREGISHRS = :NRSEQREGISHRS
                  AND $where";
        
        $params = array(":DTINICIOAPONT" => $dtini, ":DTFINALAPONT" => $dtfin, ":NRSEQREGISHRS" => $nrseqreg);
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        $contar = count($retorno);
        return $contar;
    }

    public static function validaUpdateHoras($dataInicial,$dataFinal,$horas,$horas_ant)
    {
      //Recebe as datas inicial/final a nova hora setada manualmente, e a hora anterior
      if ((($dataInicial!='')||(!is_null($dataInicial)))&&(($dataFinal!='')||(!is_null($dataFinal)))) 
      {
        //Se as datas estiverem preenchidas, é executado um if que compara as horas e verifica se são diferentes.
        if ($horas!=$horas_ant) 
        {
          //Se forem será feito ainda mais uma validação que vai verificar se o intervalo em horas entre as datas é igual à nova hora inserida
          $intervalo = \Services\Logic\DateLogic::getIntervaloHoras($dataInicial, $dataFinal);
          $intervalo = str_replace(':', '', $intervalo);
          if ((int)$intervalo != (int)$horas) 
          {
            //Se forem diferentes retorna false.
            return false;                                   
          }
          else 
          {
            //Se forem diferentes retorna true.
            return true;
          }
          }
      }
      
      return true;
    }



}