CREATE or REPLACE FUNCTION CTB_HIST_BCO(
P_CDREDUCONT IN MOVCREDBANC.CDREDUCONT%TYPE,
P_NRMOVI IN MOVCREDBANC.NRMOVICRED%TYPE,
P_CDHISTPADR IN HISTPADR.CDHISTPADR%TYPE,
P_CDEMPRESA IN TRANSFBANC.CDEMPRESA%TYPE,
P_IDTIPO VARCHAR2
) RETURN VARCHAR2
AS
   V_STDSHISTPADR VARCHAR2(5000);

BEGIN
   V_STDSHISTPADR := NULL;
   BEGIN
         SELECT DSHISTPADR    -- Traz a descrio do histrico padro passado como parmetro
           INTO V_STDSHISTPADR
           FROM HISTPADR
          WHERE CDHISTPADR = P_CDHISTPADR;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_STDSHISTPADR := NULL;
   END;
   IF P_IDTIPO = 'C' THEN  -- Movimentao de Crdito

     FOR C_HIST IN (  /*Cursor utilizado para armazenar as informaes da movimentao que podero ser gravadas no histrico */
        SELECT M.DSMOVICRED, TP.DSTPCREDBANC, MB.NRDOCMBANC, C.NMRAZSOCCLIE, C.NMFANTCLIE, F.NMRAZSOCFORN, F.NMFANTFORN,
               NVL(FORMATA_PESSOA(C.IDTPIJURCLIE, C.NRINSJURCLIE), FORMATA_PESSOA(F.IDTPIJURFORN, F.NRINSJURFORN)) INSCRICAO,
               DTMOVICRED, B.CDBANCO, B.NMBANCO, F.NRINSJURFORN, C.NRINSJURCLIE
          FROM  MOVCREDBANC M, TPCREDBANC TP, MOVBANCARIO MB, CLIENTE C, FORNECEDOR F, CONTCORR C, BANCO B
         WHERE  M.CDREDUCONT = P_CDREDUCONT
           AND  M.NRMOVICRED = P_NRMOVI
           AND  M.CDTPCREDBANC = TP.CDTPCREDBANC
           AND  M.CDREDUCONT = MB.CDREDUCONT
           AND  M. NRMOVBANC = MB.NRMOVBANC
           AND  M.CDCLIENTE = C.CDCLIENTE(+)
           AND  M.CDFORNECED = F.CDFORNECED(+)
           AND C.CDREDUCONT = M.CDREDUCONT
           AND B.CDBANCO = C.CDBANCO) LOOP

           /* Caso o histrico padro contenha algum dos mnemnicos abaixo, o mesmo ser substituido pela informao
           correspondente na movimentao. Ex: Se o histrico contiver o mnemnico [DESC], este ser substituido pela
           descriao da movimentao Bancria. */

           -- Descrio da Movimentao Bancria de Crdito
           V_STDSHISTPADR :=  Replace(V_STDSHISTPADR, '[DESC]', C_HIST.DSMOVICRED);

           -- Descrio do Tipo de Crdito Bancrio
           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR, '[TIPO]',C_HIST.DSTPCREDBANC);

           -- Descrio da Movimentao Bancria de Crdito e do Tipo de Crdito Bancrio
           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR, '[HIMB]',C_HIST.DSMOVICRED ||'('||C_HIST.DSTPCREDBANC||')');

           -- Nmero do Documento da Movimentao
           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[DOC]', C_HIST.NRDOCMBANC);

           -- DATA DA MOVIMENTACAO
           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[DTM]', C_HIST.DTMOVICRED);

           -- CODIGO DO BANCO
           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[BCO]', C_HIST.CDBANCO);

           -- NOME DO BANCO
           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[NBCO]', C_HIST.NMBANCO);

           IF NOT C_HIST.NRINSJURFORN IS NULL THEN
              -- CNPJ DO CLIENTE / FORNECEDOR
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[FOR]', C_HIST.INSCRICAO);

              -- Razo Social do Fornecedor
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[RSF]', C_HIST.NMRAZSOCFORN);

              -- NOME FANTASIA DO FORNECEDOR
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[NFF]', C_HIST.NMFANTFORN);
           END IF;

           IF NOT C_HIST.NRINSJURCLIE IS NULL THEN
              -- CNPJ DO CLIENTE / FORNECEDOR
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[CLI]', C_HIST.INSCRICAO);

              -- Razo Social do Cliente
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[RSC]', C_HIST.NMRAZSOCCLIE);

              --Nome Fantasia do Cliente
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[NFC]', C_HIST.NMFANTCLIE);
           END IF;
     END LOOP;
   ELSIF  P_IDTIPO = 'D' THEN  -- Movimentao de Dbito

      FOR C_HIST IN (
        SELECT M.DSMOVIDEBI, TP.DSTPDEBIBANC, MB.NRDOCMBANC, C.NMRAZSOCCLIE, C.NMFANTCLIE, F.NMRAZSOCFORN, F.NMFANTFORN,
               NVL(FORMATA_PESSOA(C.IDTPIJURCLIE, C.NRINSJURCLIE), FORMATA_PESSOA(F.IDTPIJURFORN, F.NRINSJURFORN)) INSCRICAO,
               DTMOVIDEBI, B.CDBANCO, B.NMBANCO,  F.NRINSJURFORN, C.NRINSJURCLIE
          FROM  MOVDEBBANC M,  TPDEBIBANC TP, MOVBANCARIO MB, CLIENTE C, FORNECEDOR F, CONTCORR C, BANCO B
         WHERE  M.CDREDUCONT   = P_CDREDUCONT
           AND  M.NRMOVIDEBI    =  P_NRMOVI
           AND  M.CDTPDEBIBANC = TP.CDTPDEBIBANC
           AND  M.CDREDUCONT   = MB.CDREDUCONT
           AND  M. NRMOVBANC   = MB.NRMOVBANC
           AND  M.CDCLIENTE    = C.CDCLIENTE(+)
           AND  M.CDFORNECED   = F.CDFORNECED(+)
           AND C.CDREDUCONT = M.CDREDUCONT
           AND B.CDBANCO = C.CDBANCO) LOOP
            
           -- Descrio da Movimentao Bancria de Dbito
           V_STDSHISTPADR :=  Replace(V_STDSHISTPADR, '[DESC]', C_HIST.DSMOVIDEBI);

           -- Descrio do Tipo de Dbito Bancrio
           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR, '[TIPO]',C_HIST.DSTPDEBIBANC);
 
           -- Descrio da Movimentao Bancria de Dbito e do Tipo de Dbito Bancrio
           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR, '[HIMB]',C_HIST.DSMOVIDEBI ||'('||C_HIST.DSTPDEBIBANC||')');

           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[DOC]', C_HIST.NRDOCMBANC);

           -- Mnemnico '[#CHQ]' no alterado pois na rotina antiga  substitudo por ''

           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[DTM]', C_HIST.DTMOVIDEBI);

           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[BCO]', C_HIST.CDBANCO);

           V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[NBCO]', C_HIST.NMBANCO);

           IF NOT C_HIST.NRINSJURFORN IS NULL THEN
              -- CNPJ DO CLIENTE / FORNECEDOR
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[FOR]', C_HIST.INSCRICAO);

              -- Razo Social do Fornecedor
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[RSF]', C_HIST.NMRAZSOCFORN);

              -- NOME FANTASIA DO FORNECEDOR
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[NFF]', C_HIST.NMFANTFORN);
           END IF;

           IF NOT C_HIST.NRINSJURCLIE IS NULL THEN
              -- CNPJ DO CLIENTE / FORNECEDOR
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[CLI]', C_HIST.INSCRICAO);

              -- Razo Social do Cliente
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[RSC]', C_HIST.NMRAZSOCCLIE);

              --Nome Fantasia do Cliente
              V_STDSHISTPADR :=  Replace( V_STDSHISTPADR,'[NFC]', C_HIST.NMFANTCLIE);
           END IF;
      END LOOP;
   ELSIF  P_IDTIPO = 'T' THEN  -- Transferncia Bancria

      FOR C_HIST IN ( SELECT TF.DSHISTTBANC, I.NRCHEQUE
                        FROM TRANSFBANC TF, ITTRANSFBANC I
                       WHERE TF.CDEMPRESA  = P_CDEMPRESA
                         AND TF.NRTRANBANC = P_NRMOVI
                         AND I.CDEMPRESA = P_CDEMPRESA
                         AND I.NRTRANBANC = P_NRMOVI) LOOP

          -- Descrio da Transferncia Bancria
          V_STDSHISTPADR := REPLACE (V_STDSHISTPADR,'[HITR]', C_HIST.DSHISTTBANC);

          -- Nmero do Cheque da Transferncia Bancria
          V_STDSHISTPADR := REPLACE (V_STDSHISTPADR,'[#CHQ]', C_HIST.NRCHEQUE);

      END LOOP;
   END IF;
   RETURN SUBSTR(V_STDSHISTPADR, 1, 200);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CTB_HIST_BCO','5.50.000'); END;
/