package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.RequisicaoExtraFlows;
import com.javaseleniumtemplate.pages.RequisicaoExtraPage;
import org.testng.annotations.Test;

public class RequisicaoExtraTests extends TestBase {

    RequisicaoExtraPage requisicaoExtraPage;
    RequisicaoExtraFlows requisicaoExtraFlows;
    LoginFlows loginFlows;

    //acessar a tela Requisição Extra
    //preencher o filtro inicial com o tipo de requisição (Produto) para que de acordo com o filtro incial, tenha que ser adicionado um produto na requisição
    //e informar também o tipo de produto. Neste caso 'Matéria Prima'
    //adicionar um produto na requisição, informando o nome do produto, quantidade, data limite de entrega e hora
    //verificar a mensagem no canto superior direiro da tela e capturar a data limite de entrega que foi adiciona, para que possa ser verificado se a data foi salva corretamente
    //capturar o número da requisição que foi adicionada para que após atualizar a tela e preencher novamente o filtro inicial possa ser informado o número da requisição
    //verificar novamente se o produto foi adicionado corretamente
    //alterar a quantidade, data limite de entrega e hora do produto. Verificar se os dados alterados, foram salvos corretamente
    //adicionar, editar e remover mensagem
    //acessar as 'Ações' da tela e gerar o relatório de 'Requisição Extra' e 'Requisição Extra (Turnos)', verificar os campos de ordenação por código e também alfabética
    //gerar o relatório da ação 'Produtos Requisitado', como 'Todos' serviços selecionados e também com serviço selecionado manualmente
    //exportar a requisição para o serviço 'ALMOÇO INFT', verificar se na tela é emitida a mensagem exportado com sucesso e recuperar o número deste requisição exportada
    //preencher novamente o filtro inicial, agora para acessar a requisição que foi exportada
    //remover a requisição que foi exportada e verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    //atualizar a tela e preencher o filtro inicial com a requisição que foi adicionada no início do teste e excluir a mesma. Verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    @Test
    public void requisicaoProdutoMateriaPrima() {
        requisicaoExtraPage = new RequisicaoExtraPage();
        requisicaoExtraFlows = new RequisicaoExtraFlows();
        loginFlows = new LoginFlows();

        String tipoProdutos = "Matéria Prima";
        String dataLimiteEntrega = "";
        String tipoRequisicao = "Produto";
        String nrRequisicao = "";
        String nrRequisicaoExportada = "";

        loginFlows.efetuarLogin();
        requisicaoExtraFlows.navegateRequisicaoExtra();
        requisicaoExtraPage.preencherFiltroInicial(tipoRequisicao, tipoProdutos);
        dataLimiteEntrega = requisicaoExtraPage.addRequisicaoProd();
        requisicaoExtraPage.verificarProdutoAdd(dataLimiteEntrega);
        nrRequisicao = requisicaoExtraPage.capturarDadosRequisicao();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, tipoProdutos);
        requisicaoExtraPage.verificarProdutoAdd(dataLimiteEntrega);
        requisicaoExtraPage.editarValoresProduto();
        requisicaoExtraPage.adicionarEditarRemoverMensagem(tipoRequisicao);
        requisicaoExtraPage.gerarRelatorioRequisicaoExtra();
        requisicaoExtraPage.gerarRelatorioAcaoProdutosRequisitados();
        nrRequisicaoExportada = requisicaoExtraPage.exportarRequisicaoProduto(nrRequisicao);
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicaoExportada, tipoProdutos);
        requisicaoExtraPage.excluirTodosProdutosRequisicao();

        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, tipoProdutos);
        requisicaoExtraPage.excluirTodosProdutosRequisicao();

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }


    //acessar a tela Requisição Extra
    //preencher o filtro inicial com o tipo de requisição (Tipo de Prato) para que de acordo com o filtro incial, tenha que ser adicionado um tipo de prato na requisição
    //e informar também o tipo de produto. Neste caso 'Matéria Prima'
    //adicionar uma requisição do 'Tipo de Prato' informando o tipo de prato, o prato, o produto e uma quantidade para o mesmo e verificar também a mensagem de sucesso no canto da tela
    //verificar os dados(tipo de prato e produto) da requisição adicionada
    //editar o tipo e prato e verificar se o produto adicionado no inicio da requisição, não foi alterado
    //alterar a quantidade do produto que foi adicionado
    //verificar os campos obrigatórios do formulário para adicionar um novo produto à uma requisição do 'Tipo de Prato'
    //tentar adicionar à está requisição um segundo produto com a quantidade 0 e verificar a mensagem que será exibida na tela
    //tentar adicionar este segundo produto também com um horário maior que da hora de início do preparo
    //e na sequência adicionar o produto com todos os campos preenchidos e verificar se os dados foram salvos corretamente
    //tentar editar a quantidade do segundo produto, já pelo aba 'Produto' onde são apresentados todos os produtos da requisição e tentar adicionar o valor zero ao mesmo, verificar a mensagem apresentar, clicar no ok e cancelar a alteração
    //remover um dos produtos adicionados à requisição
    //capturar o número da requisição que foi adicionada para que após atualizar a tela e preencher novamente o filtro inicial possa ser informado o número da requisição
    //adicionar, editar e remover mensagem
    //acessar as 'Ações' da tela e gerar o relatório de 'Requisição Extra' e 'Requisição Extra (Turnos)', verificar os campos de ordenação por código e também alfabética
    //gerar o relatório da ação 'Produtos Requisitado', como 'Todos' serviços selecionado e também com serviço selecionado manualmente
    //exportar a requisição para o serviço 'Palestra', verificar se na tela é emitida a mensagem exportado com sucesso e recuperar o número deste requisição exportada
    //preencher novamente o filtro inicial, agora para acessar a requisição que foi exportada
    //remover a requisição que foi exportada e verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    //atualizar a tela e preencher o filtro inicial com a requisição que foi adicionada no início do teste e excluir a mesma. Verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    @Test
    public void requisicaoTipoPratoMateiraPrima() {
        requisicaoExtraPage = new RequisicaoExtraPage();
        requisicaoExtraFlows = new RequisicaoExtraFlows();
        loginFlows = new LoginFlows();

        String produtosFiltroInicial = "Matéria Prima";
        String tipoRequisicao = "Tipo de Prato";
        String nrRequisicao = "";
        String nrRequisicaoExtraExportada = "";

        loginFlows.efetuarLogin();
        requisicaoExtraFlows.navegateRequisicaoExtra();
        requisicaoExtraPage.preencherFiltroInicial(tipoRequisicao, produtosFiltroInicial);
        requisicaoExtraPage.addRequisicaoTipoPrato();
        requisicaoExtraPage.verificarReqTipoPrato();
        requisicaoExtraPage.editarReqTipoPrato();
        requisicaoExtraPage.alterarQuantidadeProdutoTipoPrato();
        requisicaoExtraPage.camposObrigatorioFormProdutoReqTipoPrato();
        requisicaoExtraPage.addSegundoProdutoReqTipoPrato();
        requisicaoExtraPage.tentarEditarQuantProdTipoPratoValorZero();
        requisicaoExtraPage.removerProdutoReqTipoPrato();
        nrRequisicao = requisicaoExtraPage.capturarDadosRequisicao();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, produtosFiltroInicial);
        requisicaoExtraPage.adicionarEditarRemoverMensagem(tipoRequisicao);
        requisicaoExtraPage.gerarRelatorioRequisicaoExtra();
        requisicaoExtraPage.gerarRelatorioAcaoProdutosRequisitados();
        nrRequisicaoExtraExportada = requisicaoExtraPage.exportarRequisicaoTipoPrato(nrRequisicao);
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicaoExtraExportada, produtosFiltroInicial);
        requisicaoExtraPage.removerRequisicaoTipoPrato();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, produtosFiltroInicial);
        requisicaoExtraPage.removerRequisicaoTipoPrato();

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }


    //verificar os campos obrigatórios do filtro inicial da tela
    //preencher o filtro inicial com o tipo de requisição (Produto) para que de acordo com o filtro incial, tenha que ser adicionado um produto na requisição
    //e informar também o tipo de produto. Neste caso 'Matéria Prima'
    //verificar os campos obrigatórios do formulário para adicionar um produto à requsicição
    //adicionar um produto com todos os campos preenchidos
    //verificar os campos obrigatórios da ação 'Produtos Requisitados'
    //verificar os campos obrigatórios da ação 'Requisição Extra Automática'
    //verificar os campos obrigatórios da ação 'Exportar Requisição Extra'
    //excluir o produto que foi adicionado na requisição
    //atualizar a tela e preencher o filtro inicial para adicionar uma requisição do 'Tipo de Prato'
    //verificar os campos obrigatórios do formulário para adicionar um tipo de prato
    @Test
    public void testesComplementares() {
        requisicaoExtraPage = new RequisicaoExtraPage();
        requisicaoExtraFlows = new RequisicaoExtraFlows();
        loginFlows = new LoginFlows();

        String produtosFiltroInicial = "Matéria Prima";

        loginFlows.efetuarLogin();
        requisicaoExtraFlows.navegateRequisicaoExtra();
        requisicaoExtraPage.campoObrigatoriosFiltroInicial();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.preencherFiltroInicial("Produto", produtosFiltroInicial);
        requisicaoExtraPage.camposObrigatorioAddReqProduto();
        requisicaoExtraPage.addRequisicaoProd();
        requisicaoExtraPage.camposObrigatoriosAcaoProdutosRequisitados();
        requisicaoExtraPage.camposObrigatoriosAcaoReqExtraAuto();
        requisicaoExtraPage.camposObrigatorioAcaoExportarReqExtra();
        requisicaoExtraPage.excluirProdutoRequisicao();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.preencherFiltroInicial("Tipo de Prato", produtosFiltroInicial);
        requisicaoExtraPage.camposObrigatoriosAddTipoPrato();

        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }


    //acessar a tela Requisição Extra
    //preencher o filtro inicial com o tipo de requisição (Produto) para que de acordo com o filtro incial, tenha que ser adicionado um produto na requisição
    //e informar também o tipo de produto. Neste caso 'Consumo Fixo'
    //adicionar um produto na requisição, informando o nome do produto, quantidade, data limite de entrega e hora
    //verificar a mensagem no canto superior direiro da tela e capturar a data limite de entrega que foi adiciona, para que possa ser verificado se a data foi salva corretamente
    //capturar o número da requisição que foi adicionada para que após atualizar a tela e preencher novamente o filtro inicial possa ser informado o número da requisição
    //verificar novamente se o produto foi adicionado corretamente
    //alterar a quantidade, data limite de entrega e hora do produto. Verificar se os dados alterados, foram salvos corretamente
    //adicionar, editar e remover mensagem
    //acessar as 'Ações' da tela e gerar o relatório de 'Requisição Extra' e 'Requisição Extra (Turnos)', verificar os campos de ordenação por código e também alfabética
    //gerar o relatório da ação 'Produtos Requisitado', como 'Todos' serviços selecionado e também com serviços selecionado manualmente
    //exportar a requisição para o serviço 'ALMOÇO INFT', verificar se na tela é emitida a mensagem exportado com sucesso e recuperar o número desta requisição exportada
    //preencher novamente o filtro inicial, agora para acessar a requisição que foi exportada
    //remover a requisição que foi exportada e verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    //realizar a ação 'Importação de Consumo Por Serviço' do tipo 'Consumo Fixo' e verificar se os dados do produto importado foram salvos corretamente
    //realizar a ação de 'Requisição Extra Automática', pegar o número desta nova requisição
    //atualizar a tela e prrencher o filtro inicial com o número da requisição que foi gerada automatícamente e acessar nos tipo de produto 'Consumo Fixo' e 'Consumo Per Capita' e excluir os produtos
    //atualizar a tela e preencher o filtro inicial com a requisição que foi adicionada no início do teste e excluir a mesma. Verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    @Test
    public void requisicaoProdutoConsumoFixo() {
        requisicaoExtraPage = new RequisicaoExtraPage();
        requisicaoExtraFlows = new RequisicaoExtraFlows();
        loginFlows = new LoginFlows();

        String tipoProdutos = "Consumo Fixo";
        String dataLimiteEntrega = "";
        String tipoRequisicao = "Produto";
        String nrRequisicao = "";
        String nrRequsicaoExtraAuto = "";
        String nrRequisicaoExportada = "";

        loginFlows.efetuarLogin();
        requisicaoExtraFlows.navegateRequisicaoExtra();
        requisicaoExtraPage.preencherFiltroInicial(tipoRequisicao, tipoProdutos);
        dataLimiteEntrega = requisicaoExtraPage.addRequisicaoProd();
        requisicaoExtraPage.verificarProdutoAdd(dataLimiteEntrega);

        nrRequisicao = requisicaoExtraPage.capturarDadosRequisicao();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, tipoProdutos);
        requisicaoExtraPage.verificarProdutoAdd(dataLimiteEntrega);
        requisicaoExtraPage.editarValoresProduto();
        requisicaoExtraPage.adicionarEditarRemoverMensagem(tipoRequisicao);
        requisicaoExtraPage.gerarRelatorioRequisicaoExtra();
        requisicaoExtraPage.gerarRelatorioAcaoProdutosRequisitados();

        nrRequisicaoExportada = requisicaoExtraPage.exportarRequisicaoProduto(nrRequisicao);
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicaoExportada, tipoProdutos);
        requisicaoExtraPage.excluirTodosProdutosRequisicao();

        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, tipoProdutos);
        requisicaoExtraPage.importarConsumoPorServico(tipoProdutos);

        nrRequsicaoExtraAuto = requisicaoExtraPage.requisicaoExtraAuto(nrRequisicao);
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequsicaoExtraAuto, "Consumo Fixo");
        requisicaoExtraPage.excluirProdutoRequisicao();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequsicaoExtraAuto, "Consumo Per Capita");
        requisicaoExtraPage.excluirProdutoRequisicao();

        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, tipoProdutos);
        requisicaoExtraPage.excluirTodosProdutosRequisicao();

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }


    //acessar a tela Requisição Extra
    //preencher o filtro inicial com o tipo de requisição (Tipo de Prato) para que de acordo com o filtro incial, tenha que ser adicionado um tipo de prato na requisição
    //e informar também o tipo de produto. Neste caso 'Consumo Fixo'
    //adicionar uma requisição do 'Tipo de Prato' informando o tipo de prato, o prato, o produto e uma quantidade para o mesmo e verificar também a mensagem de sucesso no canto da tela
    //verificar os dados(tipo de prato e produto) da requisição adicionada
    //editar o tipo e prato e verificar se o produto adicionado no inicio da requisição, não foi alterado
    //alterar a quantidade do produto que foi adicionado
    //verificar os campos obrigatórios do formulário para adicionar um novo produto à uma requisição do 'Tipo de Prato'
    //tentar adicionar à está requisição um segundo produto com a quantidade 0 e verificar a mensagem que será exibida na tela
    //tentar adicionar este segundo produto também com um horário maior que da hora de início do preparo
    //e na sequência adicionar o produto com todos os campos preenchidos e verificar se os dados foram salvos corretamente
    //tentar editar a quantidade do segundo produto, já pelo aba 'Produto' onde são apresentados todos os produtos da requisição e tentar adicionar o valor zero ao mesmo, verificar a mensagem apresentar, clicar no ok e cancelar a alteração
    //remover um dos produtos adicionados à requisição
    //capturar o número da requisição que foi adicionada para que após atualizar a tela e preencher novamente o filtro inicial possa ser informado o número da requisição
    //adicionar, editar e remover mensagem
    //acessar as 'Ações' da tela e gerar o relatório de 'Requisição Extra' e 'Requisição Extra (Turnos)', verificar os campos de ordenação por código e também alfabética
    //gerar o relatório da ação 'Produtos Requisitado', com 'Todos' serviços selecionado e também com serviço selecionado manualmente
    //exportar a requisição para o serviço 'Palestra', verificar se na tela é emitida a mensagem exportado com sucesso e recuperar o número deste requisição exportada
    //preencher novamente o filtro inicial, agora para acessar a requisição que foi exportada
    //remover a requisição que foi exportada e verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    //atualizar a tela e preencher o filtro inicial com a requisição que foi adicionada no início do teste e excluir a mesma. Verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    @Test
    public void requisicaoTipoPratoConsumoFixo() {
        requisicaoExtraPage = new RequisicaoExtraPage();
        requisicaoExtraFlows = new RequisicaoExtraFlows();
        loginFlows = new LoginFlows();

        String produtosFiltroInicial = "Consumo Fixo";
        String tipoRequisicao = "Tipo de Prato";
        String nrRequisicao = "";
        String nrRequisicaoExtraExportada = "";

        loginFlows.efetuarLogin();
        requisicaoExtraFlows.navegateRequisicaoExtra();
        requisicaoExtraPage.preencherFiltroInicial(tipoRequisicao, produtosFiltroInicial);
        requisicaoExtraPage.addRequisicaoTipoPrato();
        requisicaoExtraPage.verificarReqTipoPrato();
        requisicaoExtraPage.editarReqTipoPrato();
        requisicaoExtraPage.alterarQuantidadeProdutoTipoPrato();
        requisicaoExtraPage.camposObrigatorioFormProdutoReqTipoPrato();
        requisicaoExtraPage.addSegundoProdutoReqTipoPrato();
        requisicaoExtraPage.tentarEditarQuantProdTipoPratoValorZero();
        requisicaoExtraPage.removerProdutoReqTipoPrato();
        nrRequisicao = requisicaoExtraPage.capturarDadosRequisicao();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, produtosFiltroInicial);
        requisicaoExtraPage.adicionarEditarRemoverMensagem(tipoRequisicao);
        requisicaoExtraPage.gerarRelatorioRequisicaoExtra();
        requisicaoExtraPage.gerarRelatorioAcaoProdutosRequisitados();
        nrRequisicaoExtraExportada = requisicaoExtraPage.exportarRequisicaoTipoPrato(nrRequisicao);
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicaoExtraExportada, produtosFiltroInicial);
        requisicaoExtraPage.removerRequisicaoTipoPrato();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, produtosFiltroInicial);
        requisicaoExtraPage.removerRequisicaoTipoPrato();


        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }


    //acessar a tela Requisição Extra
    //preencher o filtro inicial com o tipo de requisição (Produto) para que de acordo com o filtro incial, tenha que ser adicionado um produto na requisição
    //e informar também o tipo de produto. Neste caso 'Consumo Per Capita'
    //adicionar um produto na requisição, informando o nome do produto, quantidade, data limite de entrega e hora
    //verificar a mensagem no canto superior direiro da tela e capturar a data limite de entrega que foi adiciona, para que possa ser verificado se a data foi salva corretamente
    //capturar o número da requisição que foi adicionada para que após atualizar a tela e preencher novamente o filtro inicial possa ser informado o número da requisição
    //verificar novamente se o produto foi adicionado corretamente
    //alterar a quantidade, data limite de entrega e hora do produto. Verificar se os dados alterados, foram salvos corretamente
    //adicionar, editar e remover mensagem
    //acessar as 'Ações' da tela e gerar o relatório de 'Requisição Extra' e 'Requisição Extra (Turnos)', verificar os campos de ordenação por código e também alfabética
    //gerar o relatório da ação 'Produtos Requisitado', como 'Todos' serviços selecionado e também com serviços selecionado manualmente
    //exportar a requisição para o serviço 'ALMOÇO INFT', verificar se na tela é emitida a mensagem exportado com sucesso e recuperar o número desta requisição exportada
    //preencher novamente o filtro inicial, agora para acessar a requisição que foi exportada
    //remover a requisição que foi exportada e verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    //realizar a ação 'Importação de Consumo Por Serviço' do tipo 'Consumo Fixo' e verificar se os dados do produto importado foram salvos corretamente
    //realizar a ação de 'Requisição Extra Automática', pegar o número desta nova requisição
    //atualizar a tela e prrencher o filtro inicial com o número da requisição que foi gerada automatícamente e acessar nos tipo de produto 'Consumo Fixo' e 'Consumo Per Capita' e excluir os produtos
    //atualizar a tela e preencher o filtro inicial com a requisição que foi adicionada no início do teste e excluir a mesma. Verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    @Test
    public void requisicaoProdutoConsumoPerCapita() {
        requisicaoExtraPage = new RequisicaoExtraPage();
        requisicaoExtraFlows = new RequisicaoExtraFlows();
        loginFlows = new LoginFlows();

        String tipoProdutos = "Consumo Per Capita";
        String dataLimiteEntrega = "";
        String tipoRequisicao = "Produto";
        String nrRequisicao = "";
        String nrRequsicaoExtraAuto = "";
        String nrRequisicaoExportada = "";

        loginFlows.efetuarLogin();
        requisicaoExtraFlows.navegateRequisicaoExtra();
        requisicaoExtraPage.preencherFiltroInicial(tipoRequisicao, tipoProdutos);
        dataLimiteEntrega = requisicaoExtraPage.addRequisicaoProd();
        requisicaoExtraPage.verificarProdutoAdd(dataLimiteEntrega);

        nrRequisicao = requisicaoExtraPage.capturarDadosRequisicao();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, tipoProdutos);
        requisicaoExtraPage.verificarProdutoAdd(dataLimiteEntrega);
        requisicaoExtraPage.editarValoresProduto();
        requisicaoExtraPage.adicionarEditarRemoverMensagem(tipoRequisicao);
        requisicaoExtraPage.gerarRelatorioRequisicaoExtra();
        requisicaoExtraPage.gerarRelatorioAcaoProdutosRequisitados();

        nrRequisicaoExportada = requisicaoExtraPage.exportarRequisicaoProduto(nrRequisicao);
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicaoExportada, tipoProdutos);
        requisicaoExtraPage.excluirTodosProdutosRequisicao();

        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, tipoProdutos);
        requisicaoExtraPage.importarConsumoPorServico(tipoProdutos);

        nrRequsicaoExtraAuto = requisicaoExtraPage.requisicaoExtraAuto(nrRequisicao);
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequsicaoExtraAuto, "Consumo Fixo");
        requisicaoExtraPage.excluirProdutoRequisicao();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequsicaoExtraAuto, "Consumo Per Capita");
        requisicaoExtraPage.excluirProdutoRequisicao();

        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, tipoProdutos);
        requisicaoExtraPage.excluirTodosProdutosRequisicao();

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }


    //acessar a tela Requisição Extra
    //preencher o filtro inicial com o tipo de requisição (Tipo de Prato) para que de acordo com o filtro incial, tenha que ser adicionado um tipo de prato na requisição
    //e informar também o tipo de produto. Neste caso 'Consumo Per Capita'
    //adicionar uma requisição do 'Tipo de Prato' informando o tipo de prato, o prato, o produto e uma quantidade para o mesmo e verificar também a mensagem de sucesso no canto da tela
    //verificar os dados(tipo de prato e produto) da requisição adicionada
    //editar o tipo e prato e verificar se o produto adicionado no inicio da requisição, não foi alterado
    //alterar a quantidade do produto que foi adicionado
    //verificar os campos obrigatórios do formulário para adicionar um novo produto à uma requisição do 'Tipo de Prato'
    //tentar adicionar à está requisição um segundo produto com a quantidade 0 e verificar a mensagem que será exibida na tela
    //tentar adicionar este segundo produto também com um horário maior que da hora de início do preparo
    //e na sequência adicionar o produto com todos os campos preenchidos e verificar se os dados foram salvos corretamente
    //tentar editar a quantidade do segundo produto, já pelo aba 'Produto' onde são apresentados todos os produtos da requisição e tentar adicionar o valor zero ao mesmo, verificar a mensagem apresentar, clicar no ok e cancelar a alteração
    //remover um dos produtos adicionados à requisição
    //capturar o número da requisição que foi adicionada para que após atualizar a tela e preencher novamente o filtro inicial possa ser informado o número da requisição
    //adicionar, editar e remover mensagem
    //acessar as 'Ações' da tela e gerar o relatório de 'Requisição Extra' e 'Requisição Extra (Turnos)', verificar os campos de ordenação por código e também alfabética
    //gerar o relatório da ação 'Produtos Requisitado', com 'Todos' serviços selecionado e também com serviço selecionado manualmente
    //exportar a requisição para o serviço 'Palestra', verificar se na tela é emitida a mensagem exportado com sucesso e recuperar o número deste requisição exportada
    //preencher novamente o filtro inicial, agora para acessar a requisição que foi exportada
    //remover a requisição que foi exportada e verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    //atualizar a tela e preencher o filtro inicial com a requisição que foi adicionada no início do teste e excluir a mesma. Verificar se no canto superior da tela é informanda a mensagem de que foi excluído com sucesso
    @Test
    public void requisicaoTipoPratoConsumoPerCapita() {
        requisicaoExtraPage = new RequisicaoExtraPage();
        requisicaoExtraFlows = new RequisicaoExtraFlows();
        loginFlows = new LoginFlows();

        String produtosFiltroInicial = "Consumo Per Capita";
        String tipoRequisicao = "Tipo de Prato";
        String nrRequisicao = "";
        String nrRequisicaoExtraExportada = "";

        loginFlows.efetuarLogin();
        requisicaoExtraFlows.navegateRequisicaoExtra();
        requisicaoExtraPage.preencherFiltroInicial(tipoRequisicao, produtosFiltroInicial);
        requisicaoExtraPage.addRequisicaoTipoPrato();
        requisicaoExtraPage.verificarReqTipoPrato();
        requisicaoExtraPage.editarReqTipoPrato();
        requisicaoExtraPage.alterarQuantidadeProdutoTipoPrato();
        requisicaoExtraPage.camposObrigatorioFormProdutoReqTipoPrato();
        requisicaoExtraPage.addSegundoProdutoReqTipoPrato();
        requisicaoExtraPage.tentarEditarQuantProdTipoPratoValorZero();
        requisicaoExtraPage.removerProdutoReqTipoPrato();
        nrRequisicao = requisicaoExtraPage.capturarDadosRequisicao();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, produtosFiltroInicial);
        requisicaoExtraPage.adicionarEditarRemoverMensagem(tipoRequisicao);
        requisicaoExtraPage.gerarRelatorioRequisicaoExtra();
        requisicaoExtraPage.gerarRelatorioAcaoProdutosRequisitados();
        nrRequisicaoExtraExportada = requisicaoExtraPage.exportarRequisicaoTipoPrato(nrRequisicao);
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicaoExtraExportada, produtosFiltroInicial);
        requisicaoExtraPage.removerRequisicaoTipoPrato();
        requisicaoExtraPage.refresh();
        requisicaoExtraPage.filtroInicialParaVerificarRequisicaoAdd(tipoRequisicao, nrRequisicao, produtosFiltroInicial);
        requisicaoExtraPage.removerRequisicaoTipoPrato();

        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

}